#include "MainLoop.hpp"
#include "Screen.hpp"
#include "Global.hpp"

void setup()
{
	USBDevice.init();
	USBDevice.attach();
	SerialUSB.begin(115200);
	MainLoop_Setup();
	Global& global = Global::GetInstance();
	global.micros_time = micros();
	global.screen_flip_time = 1000000 / Screen::FPS;
}

void loop()
{
	Global& global = Global::GetInstance();
	global.interval_time = micros() - global.micros_time;
	if(global.interval_time > global.screen_flip_time)
	{
		MainLoop_Loop();
		global.micros_time = micros();
	}
	MainLoop_NoWaitLoop();
}
