#include <string.h>
#include "TinyLibrary.hpp"
#include "Global.hpp"
#include "Resume.hpp"

#if defined(_WIN32) || defined(__ANDROID__) || defined(__APPLE__)
static const char* RESUME_FILEPATH = "Resume.sav";
static const char* RESUME_FILEPATH_JP = "Resume.sav";
#else
static const char* RESUME_FILEPATH = "KemonoRogue/Resume.sav";
static const char* RESUME_FILEPATH_JP = "KemonoRogue_jp/Resume.sav";
#endif

bool Resume::Load(Resume::Data* data)
{
	Global& global = Global::GetInstance();
	TinyFile file;
	if(global.game_data.GetLanguage() == GameData::LANGUAGE_ENGLISH)
	{
		if(file.Open(RESUME_FILEPATH, TinyFile::READ) == false)
		{
			return false;
		}
	}
	else
	{
		if(file.Open(RESUME_FILEPATH_JP, TinyFile::READ) == false)
		{
			return false;
		}
	}
	file.Read(data, sizeof(Resume::Data));
	file.Close();
	if(data->floor == 0)
	{
		return false;
	}
	return true;
}

void Resume::Save(Resume::Data* data)
{
	Global& global = Global::GetInstance();
	TinyFile file;
	if(global.game_data.GetLanguage() == GameData::LANGUAGE_ENGLISH)
	{
		if(file.Open(RESUME_FILEPATH, TinyFile::WRITE) == false)
		{
			return;
		}
	}
	else
	{
		if(file.Open(RESUME_FILEPATH_JP, TinyFile::WRITE) == false)
		{
			return;
		}
	}
	file.Write(data, sizeof(Resume::Data));
	file.Close();
}

void Resume::DeleteResumeDataFile(void)
{
	Global& global = Global::GetInstance();
	Resume::Data data;
	memset(&data, 0, sizeof(Resume::Data));
	TinyFile file;
	if(global.game_data.GetLanguage() == GameData::LANGUAGE_ENGLISH)
	{
		if(file.Open(RESUME_FILEPATH, TinyFile::WRITE) == false)
		{
			return;
		}
	}
	else
	{
		if(file.Open(RESUME_FILEPATH_JP, TinyFile::WRITE) == false)
		{
			return;
		}
	}
	file.Write(&data, sizeof(Resume::Data));
	file.Close();
}
